/* MediaMetadata.c generated by valac 0.48.15, the Vala compiler
 * generated from MediaMetadata.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#define _XOPEN_SOURCE

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>
#include <time.h>
#include <stdio.h>

#define TYPE_MEDIA_METADATA (media_metadata_get_type ())
#define MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_METADATA, MediaMetadata))
#define MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_METADATA, MediaMetadataClass))
#define IS_MEDIA_METADATA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_METADATA))
#define IS_MEDIA_METADATA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_METADATA))
#define MEDIA_METADATA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_METADATA, MediaMetadataClass))

typedef struct _MediaMetadata MediaMetadata;
typedef struct _MediaMetadataClass MediaMetadataClass;
typedef struct _MediaMetadataPrivate MediaMetadataPrivate;

#define TYPE_METADATA_DATE_TIME (metadata_date_time_get_type ())
#define METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTime))
#define METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))
#define IS_METADATA_DATE_TIME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_METADATA_DATE_TIME))
#define IS_METADATA_DATE_TIME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_METADATA_DATE_TIME))
#define METADATA_DATE_TIME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_METADATA_DATE_TIME, MetadataDateTimeClass))

typedef struct _MetadataDateTime MetadataDateTime;
typedef struct _MetadataDateTimeClass MetadataDateTimeClass;
typedef struct _ParamSpecMediaMetadata ParamSpecMediaMetadata;

#define TYPE_METADATA_RATIONAL (metadata_rational_get_type ())
typedef struct _MetadataRational MetadataRational;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MetadataDateTimePrivate MetadataDateTimePrivate;
#define _metadata_date_time_unref0(var) ((var == NULL) ? NULL : (var = (metadata_date_time_unref (var), NULL)))
typedef struct _ParamSpecMetadataDateTime ParamSpecMetadataDateTime;

struct _MediaMetadata {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MediaMetadataPrivate * priv;
};

struct _MediaMetadataClass {
	GTypeClass parent_class;
	void (*finalize) (MediaMetadata *self);
	void (*read_from_file) (MediaMetadata* self, GFile* file, GError** error);
	MetadataDateTime* (*get_creation_date_time) (MediaMetadata* self);
	gchar* (*get_title) (MediaMetadata* self);
	gchar* (*get_comment) (MediaMetadata* self);
};

struct _ParamSpecMediaMetadata {
	GParamSpec parent_instance;
};

struct _MetadataRational {
	gint numerator;
	gint denominator;
};

typedef enum  {
	METADATA_DATE_TIME_ERROR_INVALID_FORMAT,
	METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT
} MetadataDateTimeError;
#define METADATA_DATE_TIME_ERROR metadata_date_time_error_quark ()
struct _MetadataDateTime {
	GTypeInstance parent_instance;
	volatile int ref_count;
	MetadataDateTimePrivate * priv;
};

struct _MetadataDateTimeClass {
	GTypeClass parent_class;
	void (*finalize) (MetadataDateTime *self);
};

struct _MetadataDateTimePrivate {
	time_t timestamp;
};

struct _ParamSpecMetadataDateTime {
	GParamSpec parent_instance;
};

static gpointer media_metadata_parent_class = NULL;
static gint MetadataDateTime_private_offset;
static gpointer metadata_date_time_parent_class = NULL;

gpointer media_metadata_ref (gpointer instance);
void media_metadata_unref (gpointer instance);
GParamSpec* param_spec_media_metadata (const gchar* name,
                                       const gchar* nick,
                                       const gchar* blurb,
                                       GType object_type,
                                       GParamFlags flags);
void value_set_media_metadata (GValue* value,
                               gpointer v_object);
void value_take_media_metadata (GValue* value,
                                gpointer v_object);
gpointer value_get_media_metadata (const GValue* value);
GType media_metadata_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaMetadata, media_metadata_unref)
gpointer metadata_date_time_ref (gpointer instance);
void metadata_date_time_unref (gpointer instance);
GParamSpec* param_spec_metadata_date_time (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
void value_set_metadata_date_time (GValue* value,
                                   gpointer v_object);
void value_take_metadata_date_time (GValue* value,
                                    gpointer v_object);
gpointer value_get_metadata_date_time (const GValue* value);
GType metadata_date_time_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MetadataDateTime, metadata_date_time_unref)
void media_metadata_read_from_file (MediaMetadata* self,
                                    GFile* file,
                                    GError** error);
MetadataDateTime* media_metadata_get_creation_date_time (MediaMetadata* self);
gchar* media_metadata_get_title (MediaMetadata* self);
gchar* media_metadata_get_comment (MediaMetadata* self);
static void media_metadata_real_read_from_file (MediaMetadata* self,
                                         GFile* file,
                                         GError** error);
static MetadataDateTime* media_metadata_real_get_creation_date_time (MediaMetadata* self);
static gchar* media_metadata_real_get_title (MediaMetadata* self);
static gchar* media_metadata_real_get_comment (MediaMetadata* self);
MediaMetadata* media_metadata_construct (GType object_type);
static void media_metadata_finalize (MediaMetadata * obj);
static GType media_metadata_get_type_once (void);
GType metadata_rational_get_type (void) G_GNUC_CONST;
MetadataRational* metadata_rational_dup (const MetadataRational* self);
void metadata_rational_free (MetadataRational* self);
void metadata_rational_init (MetadataRational *self,
                             gint numerator,
                             gint denominator);
static gboolean metadata_rational_is_component_valid (MetadataRational *self,
                                               gint component);
gboolean metadata_rational_is_valid (MetadataRational *self);
gchar* metadata_rational_to_string (MetadataRational *self);
GQuark metadata_date_time_error_quark (void);
MetadataDateTime* metadata_date_time_new (time_t timestamp);
MetadataDateTime* metadata_date_time_construct (GType object_type,
                                                time_t timestamp);
MetadataDateTime* metadata_date_time_new_from_exif (const gchar* label,
                                                    GError** error);
MetadataDateTime* metadata_date_time_construct_from_exif (GType object_type,
                                                          const gchar* label,
                                                          GError** error);
gboolean metadata_date_time_from_exif_date_time (const gchar* date_time,
                                                 time_t* timestamp);
MetadataDateTime* metadata_date_time_new_from_iptc (const gchar* date,
                                                    const gchar* time,
                                                    GError** error);
MetadataDateTime* metadata_date_time_construct_from_iptc (GType object_type,
                                                          const gchar* date,
                                                          const gchar* time,
                                                          GError** error);
MetadataDateTime* metadata_date_time_new_from_xmp (const gchar* label,
                                                   GError** error);
MetadataDateTime* metadata_date_time_construct_from_xmp (GType object_type,
                                                         const gchar* label,
                                                         GError** error);
time_t metadata_date_time_get_timestamp (MetadataDateTime* self);
gchar* metadata_date_time_get_exif_label (MetadataDateTime* self);
gchar* metadata_date_time_to_exif_date_time (time_t timestamp);
gchar* metadata_date_time_get_xmp_label (MetadataDateTime* self);
gchar* metadata_date_time_to_string (MetadataDateTime* self);
static void metadata_date_time_finalize (MetadataDateTime * obj);
static GType metadata_date_time_get_type_once (void);

static void
media_metadata_real_read_from_file (MediaMetadata* self,
                                    GFile* file,
                                    GError** error)
{
	g_critical ("Type `%s' does not implement abstract method `media_metadata_read_from_file'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return;
}

void
media_metadata_read_from_file (MediaMetadata* self,
                               GFile* file,
                               GError** error)
{
	g_return_if_fail (IS_MEDIA_METADATA (self));
	MEDIA_METADATA_GET_CLASS (self)->read_from_file (self, file, error);
}

static MetadataDateTime*
media_metadata_real_get_creation_date_time (MediaMetadata* self)
{
	g_critical ("Type `%s' does not implement abstract method `media_metadata_get_creation_date_time'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

MetadataDateTime*
media_metadata_get_creation_date_time (MediaMetadata* self)
{
	g_return_val_if_fail (IS_MEDIA_METADATA (self), NULL);
	return MEDIA_METADATA_GET_CLASS (self)->get_creation_date_time (self);
}

static gchar*
media_metadata_real_get_title (MediaMetadata* self)
{
	g_critical ("Type `%s' does not implement abstract method `media_metadata_get_title'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

gchar*
media_metadata_get_title (MediaMetadata* self)
{
	g_return_val_if_fail (IS_MEDIA_METADATA (self), NULL);
	return MEDIA_METADATA_GET_CLASS (self)->get_title (self);
}

static gchar*
media_metadata_real_get_comment (MediaMetadata* self)
{
	g_critical ("Type `%s' does not implement abstract method `media_metadata_get_comment'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
	return NULL;
}

gchar*
media_metadata_get_comment (MediaMetadata* self)
{
	g_return_val_if_fail (IS_MEDIA_METADATA (self), NULL);
	return MEDIA_METADATA_GET_CLASS (self)->get_comment (self);
}

MediaMetadata*
media_metadata_construct (GType object_type)
{
	MediaMetadata* self = NULL;
	self = (MediaMetadata*) g_type_create_instance (object_type);
	return self;
}

static void
value_media_metadata_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_media_metadata_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		media_metadata_unref (value->data[0].v_pointer);
	}
}

static void
value_media_metadata_copy_value (const GValue* src_value,
                                 GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = media_metadata_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_media_metadata_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_media_metadata_collect_value (GValue* value,
                                    guint n_collect_values,
                                    GTypeCValue* collect_values,
                                    guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		MediaMetadata * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = media_metadata_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_media_metadata_lcopy_value (const GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
	MediaMetadata ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = media_metadata_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_media_metadata (const gchar* name,
                           const gchar* nick,
                           const gchar* blurb,
                           GType object_type,
                           GParamFlags flags)
{
	ParamSpecMediaMetadata* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_MEDIA_METADATA), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_media_metadata (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA), NULL);
	return value->data[0].v_pointer;
}

void
value_set_media_metadata (GValue* value,
                          gpointer v_object)
{
	MediaMetadata * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEDIA_METADATA));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		media_metadata_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		media_metadata_unref (old);
	}
}

void
value_take_media_metadata (GValue* value,
                           gpointer v_object)
{
	MediaMetadata * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_MEDIA_METADATA));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_MEDIA_METADATA));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		media_metadata_unref (old);
	}
}

static void
media_metadata_class_init (MediaMetadataClass * klass,
                           gpointer klass_data)
{
	media_metadata_parent_class = g_type_class_peek_parent (klass);
	((MediaMetadataClass *) klass)->finalize = media_metadata_finalize;
	((MediaMetadataClass *) klass)->read_from_file = (void (*) (MediaMetadata*, GFile*, GError**)) media_metadata_real_read_from_file;
	((MediaMetadataClass *) klass)->get_creation_date_time = (MetadataDateTime* (*) (MediaMetadata*)) media_metadata_real_get_creation_date_time;
	((MediaMetadataClass *) klass)->get_title = (gchar* (*) (MediaMetadata*)) media_metadata_real_get_title;
	((MediaMetadataClass *) klass)->get_comment = (gchar* (*) (MediaMetadata*)) media_metadata_real_get_comment;
}

static void
media_metadata_instance_init (MediaMetadata * self,
                              gpointer klass)
{
	self->ref_count = 1;
}

static void
media_metadata_finalize (MediaMetadata * obj)
{
	MediaMetadata * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_METADATA, MediaMetadata);
	g_signal_handlers_destroy (self);
}

static GType
media_metadata_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_media_metadata_init, value_media_metadata_free_value, value_media_metadata_copy_value, value_media_metadata_peek_pointer, "p", value_media_metadata_collect_value, "p", value_media_metadata_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MediaMetadataClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_metadata_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaMetadata), 0, (GInstanceInitFunc) media_metadata_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType media_metadata_type_id;
	media_metadata_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MediaMetadata", &g_define_type_info, &g_define_type_fundamental_info, G_TYPE_FLAG_ABSTRACT);
	return media_metadata_type_id;
}

GType
media_metadata_get_type (void)
{
	static volatile gsize media_metadata_type_id__volatile = 0;
	if (g_once_init_enter (&media_metadata_type_id__volatile)) {
		GType media_metadata_type_id;
		media_metadata_type_id = media_metadata_get_type_once ();
		g_once_init_leave (&media_metadata_type_id__volatile, media_metadata_type_id);
	}
	return media_metadata_type_id__volatile;
}

gpointer
media_metadata_ref (gpointer instance)
{
	MediaMetadata * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
media_metadata_unref (gpointer instance)
{
	MediaMetadata * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		MEDIA_METADATA_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

void
metadata_rational_init (MetadataRational *self,
                        gint numerator,
                        gint denominator)
{
	memset (self, 0, sizeof (MetadataRational));
	(*self).numerator = numerator;
	(*self).denominator = denominator;
}

static gboolean
metadata_rational_is_component_valid (MetadataRational *self,
                                      gint component)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	if (component >= 0) {
		_tmp0_ = component <= 1000000;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

gboolean
metadata_rational_is_valid (MetadataRational *self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
	if (metadata_rational_is_component_valid (&(*self), (*self).numerator)) {
		_tmp0_ = metadata_rational_is_component_valid (&(*self), (*self).denominator);
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

gchar*
metadata_rational_to_string (MetadataRational *self)
{
	gchar* _tmp0_ = NULL;
	gchar* result = NULL;
	if (metadata_rational_is_valid (&(*self))) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup_printf ("%d/%d", (*self).numerator, (*self).denominator);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp1_;
	} else {
		gchar* _tmp2_;
		_tmp2_ = g_strdup ("");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp2_;
	}
	result = _tmp0_;
	return result;
}

MetadataRational*
metadata_rational_dup (const MetadataRational* self)
{
	MetadataRational* dup;
	dup = g_new0 (MetadataRational, 1);
	memcpy (dup, self, sizeof (MetadataRational));
	return dup;
}

void
metadata_rational_free (MetadataRational* self)
{
	g_free (self);
}

static GType
metadata_rational_get_type_once (void)
{
	GType metadata_rational_type_id;
	metadata_rational_type_id = g_boxed_type_register_static ("MetadataRational", (GBoxedCopyFunc) metadata_rational_dup, (GBoxedFreeFunc) metadata_rational_free);
	return metadata_rational_type_id;
}

GType
metadata_rational_get_type (void)
{
	static volatile gsize metadata_rational_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_rational_type_id__volatile)) {
		GType metadata_rational_type_id;
		metadata_rational_type_id = metadata_rational_get_type_once ();
		g_once_init_leave (&metadata_rational_type_id__volatile, metadata_rational_type_id);
	}
	return metadata_rational_type_id__volatile;
}

GQuark
metadata_date_time_error_quark (void)
{
	return g_quark_from_static_string ("metadata-date-time-error-quark");
}

static inline gpointer
metadata_date_time_get_instance_private (MetadataDateTime* self)
{
	return G_STRUCT_MEMBER_P (self, MetadataDateTime_private_offset);
}

MetadataDateTime*
metadata_date_time_construct (GType object_type,
                              time_t timestamp)
{
	MetadataDateTime* self = NULL;
	self = (MetadataDateTime*) g_type_create_instance (object_type);
	self->priv->timestamp = timestamp;
	return self;
}

MetadataDateTime*
metadata_date_time_new (time_t timestamp)
{
	return metadata_date_time_construct (TYPE_METADATA_DATE_TIME, timestamp);
}

MetadataDateTime*
metadata_date_time_construct_from_exif (GType object_type,
                                        const gchar* label,
                                        GError** error)
{
	MetadataDateTime* self = NULL;
	time_t _tmp0_ = 0;
	gboolean _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (label != NULL, NULL);
	self = (MetadataDateTime*) g_type_create_instance (object_type);
	_tmp1_ = metadata_date_time_from_exif_date_time (label, &_tmp0_);
	self->priv->timestamp = _tmp0_;
	if (!_tmp1_) {
		GError* _tmp2_;
		_tmp2_ = g_error_new (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_INVALID_FORMAT, "%s is not EXIF format date/time", label);
		_inner_error0_ = _tmp2_;
		if (_inner_error0_->domain == METADATA_DATE_TIME_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_metadata_date_time_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	return self;
}

MetadataDateTime*
metadata_date_time_new_from_exif (const gchar* label,
                                  GError** error)
{
	return metadata_date_time_construct_from_exif (TYPE_METADATA_DATE_TIME, label, error);
}

MetadataDateTime*
metadata_date_time_construct_from_iptc (GType object_type,
                                        const gchar* date,
                                        const gchar* time,
                                        GError** error)
{
	MetadataDateTime* self = NULL;
	GError* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (date != NULL, NULL);
	g_return_val_if_fail (time != NULL, NULL);
	self = (MetadataDateTime*) g_type_create_instance (object_type);
	_tmp0_ = g_error_new_literal (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_UNSUPPORTED_FORMAT, "IPTC date/time format not currently supported");
	_inner_error0_ = _tmp0_;
	if (_inner_error0_->domain == METADATA_DATE_TIME_ERROR) {
		g_propagate_error (error, _inner_error0_);
		_metadata_date_time_unref0 (self);
		return NULL;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	return self;
}

MetadataDateTime*
metadata_date_time_new_from_iptc (const gchar* date,
                                  const gchar* time,
                                  GError** error)
{
	return metadata_date_time_construct_from_iptc (TYPE_METADATA_DATE_TIME, date, time, error);
}

MetadataDateTime*
metadata_date_time_construct_from_xmp (GType object_type,
                                       const gchar* label,
                                       GError** error)
{
	MetadataDateTime* self = NULL;
	GTimeVal time_val = {0};
	GTimeVal _tmp1_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (label != NULL, NULL);
	self = (MetadataDateTime*) g_type_create_instance (object_type);
	g_get_current_time (&time_val);
	if (!g_time_val_from_iso8601 (label, &time_val)) {
		GError* _tmp0_;
		_tmp0_ = g_error_new (METADATA_DATE_TIME_ERROR, METADATA_DATE_TIME_ERROR_INVALID_FORMAT, "%s is not XMP format date/time", label);
		_inner_error0_ = _tmp0_;
		if (_inner_error0_->domain == METADATA_DATE_TIME_ERROR) {
			g_propagate_error (error, _inner_error0_);
			_metadata_date_time_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp1_ = time_val;
	self->priv->timestamp = (time_t) _tmp1_.tv_sec;
	return self;
}

MetadataDateTime*
metadata_date_time_new_from_xmp (const gchar* label,
                                 GError** error)
{
	return metadata_date_time_construct_from_xmp (TYPE_METADATA_DATE_TIME, label, error);
}

time_t
metadata_date_time_get_timestamp (MetadataDateTime* self)
{
	time_t result = 0;
	g_return_val_if_fail (IS_METADATA_DATE_TIME (self), 0);
	result = self->priv->timestamp;
	return result;
}

gchar*
metadata_date_time_get_exif_label (MetadataDateTime* self)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (IS_METADATA_DATE_TIME (self), NULL);
	_tmp0_ = metadata_date_time_to_exif_date_time (self->priv->timestamp);
	result = _tmp0_;
	return result;
}

gchar*
metadata_date_time_get_xmp_label (MetadataDateTime* self)
{
	GTimeVal time_val = {0};
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (IS_METADATA_DATE_TIME (self), NULL);
	g_get_current_time (&time_val);
	time_val.tv_sec = (glong) self->priv->timestamp;
	time_val.tv_usec = (glong) 0;
	_tmp0_ = g_time_val_to_iso8601 (&time_val);
	result = _tmp0_;
	return result;
}

gboolean
metadata_date_time_from_exif_date_time (const gchar* date_time,
                                        time_t* timestamp)
{
	time_t _vala_timestamp = 0;
	struct tm tm = {0};
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	struct tm _tmp8_;
	gint _tmp14_;
	gboolean result = FALSE;
	g_return_val_if_fail (date_time != NULL, FALSE);
	_vala_timestamp = (time_t) 0;
	memset (&tm, 0, sizeof (struct tm));
	if (sscanf (date_time, "%d:%d:%d %d:%d:%d", &tm.tm_year, &tm.tm_mon, &tm.tm_mday, &tm.tm_hour, &tm.tm_min, &tm.tm_sec) != 6) {
		gchar* tmp = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp0_ = g_strdup (date_time);
		tmp = _tmp0_;
		_tmp1_ = tmp;
		g_strcanon (_tmp1_, "0123456789", ' ');
		_tmp2_ = tmp;
		if (sscanf (_tmp2_, "%4d%2d%2d%2d%2d%2d", &tm.tm_year, &tm.tm_mon, &tm.tm_mday, &tm.tm_hour, &tm.tm_min, &tm.tm_sec) != 6) {
			result = FALSE;
			_g_free0 (tmp);
			if (timestamp) {
				*timestamp = _vala_timestamp;
			}
			return result;
		}
		_g_free0 (tmp);
	}
	_tmp8_ = tm;
	if (_tmp8_.tm_year <= 1900) {
		_tmp7_ = TRUE;
	} else {
		struct tm _tmp9_;
		_tmp9_ = tm;
		_tmp7_ = _tmp9_.tm_mon <= 0;
	}
	if (_tmp7_) {
		_tmp6_ = TRUE;
	} else {
		struct tm _tmp10_;
		_tmp10_ = tm;
		_tmp6_ = _tmp10_.tm_mday < 0;
	}
	if (_tmp6_) {
		_tmp5_ = TRUE;
	} else {
		struct tm _tmp11_;
		_tmp11_ = tm;
		_tmp5_ = _tmp11_.tm_hour < 0;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		struct tm _tmp12_;
		_tmp12_ = tm;
		_tmp4_ = _tmp12_.tm_min < 0;
	}
	if (_tmp4_) {
		_tmp3_ = TRUE;
	} else {
		struct tm _tmp13_;
		_tmp13_ = tm;
		_tmp3_ = _tmp13_.tm_sec < 0;
	}
	if (_tmp3_) {
		result = FALSE;
		if (timestamp) {
			*timestamp = _vala_timestamp;
		}
		return result;
	}
	tm.tm_year = tm.tm_year - 1900;
	_tmp14_ = tm.tm_mon;
	tm.tm_mon = _tmp14_ - 1;
	tm.tm_isdst = -1;
	_vala_timestamp = mktime (&tm);
	result = TRUE;
	if (timestamp) {
		*timestamp = _vala_timestamp;
	}
	return result;
}

static void
g_time_local (time_t time,
              struct tm* result)
{
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
	localtime_r (&time, &_tmp0_);
	_result_ = _tmp0_;
	*result = _result_;
	return;
}

static gchar*
g_time_format (struct tm *self,
               const gchar* format)
{
	gchar* buffer = NULL;
	gchar* _tmp0_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp1_;
	gchar* result = NULL;
	g_return_val_if_fail (format != NULL, NULL);
	_tmp0_ = g_new0 (gchar, 64);
	buffer = _tmp0_;
	buffer_length1 = 64;
	_buffer_size_ = buffer_length1;
	strftime (buffer, (gint) buffer_length1, format, &(*self));
	_tmp1_ = g_strdup ((const gchar*) buffer);
	result = _tmp1_;
	buffer = (g_free (buffer), NULL);
	return result;
}

gchar*
metadata_date_time_to_exif_date_time (time_t timestamp)
{
	struct tm _tmp0_ = {0};
	gchar* _tmp1_;
	gchar* result = NULL;
	g_time_local (timestamp, &_tmp0_);
	_tmp1_ = g_time_format (&_tmp0_, "%Y:%m:%d %H:%M:%S");
	result = _tmp1_;
	return result;
}

gchar*
metadata_date_time_to_string (MetadataDateTime* self)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (IS_METADATA_DATE_TIME (self), NULL);
	_tmp0_ = metadata_date_time_to_exif_date_time (self->priv->timestamp);
	result = _tmp0_;
	return result;
}

static void
value_metadata_date_time_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
value_metadata_date_time_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		metadata_date_time_unref (value->data[0].v_pointer);
	}
}

static void
value_metadata_date_time_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = metadata_date_time_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
value_metadata_date_time_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
value_metadata_date_time_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		MetadataDateTime * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = metadata_date_time_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
value_metadata_date_time_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	MetadataDateTime ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = metadata_date_time_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
param_spec_metadata_date_time (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	ParamSpecMetadataDateTime* spec;
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_METADATA_DATE_TIME), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
value_get_metadata_date_time (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME), NULL);
	return value->data[0].v_pointer;
}

void
value_set_metadata_date_time (GValue* value,
                              gpointer v_object)
{
	MetadataDateTime * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_METADATA_DATE_TIME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		metadata_date_time_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		metadata_date_time_unref (old);
	}
}

void
value_take_metadata_date_time (GValue* value,
                               gpointer v_object)
{
	MetadataDateTime * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_METADATA_DATE_TIME));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_METADATA_DATE_TIME));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		metadata_date_time_unref (old);
	}
}

static void
metadata_date_time_class_init (MetadataDateTimeClass * klass,
                               gpointer klass_data)
{
	metadata_date_time_parent_class = g_type_class_peek_parent (klass);
	((MetadataDateTimeClass *) klass)->finalize = metadata_date_time_finalize;
	g_type_class_adjust_private_offset (klass, &MetadataDateTime_private_offset);
}

static void
metadata_date_time_instance_init (MetadataDateTime * self,
                                  gpointer klass)
{
	self->priv = metadata_date_time_get_instance_private (self);
	self->ref_count = 1;
}

static void
metadata_date_time_finalize (MetadataDateTime * obj)
{
	MetadataDateTime * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_METADATA_DATE_TIME, MetadataDateTime);
	g_signal_handlers_destroy (self);
}

static GType
metadata_date_time_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { value_metadata_date_time_init, value_metadata_date_time_free_value, value_metadata_date_time_copy_value, value_metadata_date_time_peek_pointer, "p", value_metadata_date_time_collect_value, "p", value_metadata_date_time_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (MetadataDateTimeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) metadata_date_time_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MetadataDateTime), 0, (GInstanceInitFunc) metadata_date_time_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType metadata_date_time_type_id;
	metadata_date_time_type_id = g_type_register_fundamental (g_type_fundamental_next (), "MetadataDateTime", &g_define_type_info, &g_define_type_fundamental_info, 0);
	MetadataDateTime_private_offset = g_type_add_instance_private (metadata_date_time_type_id, sizeof (MetadataDateTimePrivate));
	return metadata_date_time_type_id;
}

GType
metadata_date_time_get_type (void)
{
	static volatile gsize metadata_date_time_type_id__volatile = 0;
	if (g_once_init_enter (&metadata_date_time_type_id__volatile)) {
		GType metadata_date_time_type_id;
		metadata_date_time_type_id = metadata_date_time_get_type_once ();
		g_once_init_leave (&metadata_date_time_type_id__volatile, metadata_date_time_type_id);
	}
	return metadata_date_time_type_id__volatile;
}

gpointer
metadata_date_time_ref (gpointer instance)
{
	MetadataDateTime * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
metadata_date_time_unref (gpointer instance)
{
	MetadataDateTime * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		METADATA_DATE_TIME_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

